<?php
/**
 * XOOPS editor
 *
 * @copyright       The XOOPS Project http://sourceforge.net/projects/xoops/
 * @license         http://www.fsf.org/copyleft/gpl.html GNU public license
 * @package         class
 * @subpackage      editor
 * @since           2.3.0
 * @author          Taiwen Jiang <phppp@users.sourceforge.net>
 * @version         $Id: english.php 1573 2008-05-04 15:24:06Z phppp $
 */

define("_XOOPS_EDITOR_KOIVI", "Koivi WYSIWYG Editor");

define("_XK_LEFTTORIGHT","Left-Hand Writing");
define("_XK_RIGHTTOLEFT","Right-Hand Writing");

define("_MSC_SMILIES","Smilies");
define("_MSC_CLICKASMILIE","Click a smilie to insert it into your message.");
define("_MSC_CODE","Code");
define("_MSC_EMOTION","Emotion");

define('_XK_FONT','Font');
define('_XK_FONT_SIZE','Size');
define('_XK_FONT_XSMALL','X Small');
define('_XK_FONT_SMALL','Small');
define('_XK_FONT_MEDIUM','Medium');
define('_XK_FONT_LARGE','Large');
define('_XK_FONT_XLARGE','X Large');
define('_XK_FONT_XXLARGE','XX Large');
define('_XK_FONT_FORMAT','Format');
define('_XK_FONT_NONE','None');
define('_XK_FONT_HEADING1','Heading 1');
define('_XK_FONT_HEADING2','Heading 2');
define('_XK_FONT_HEADING3','Heading 3');
define('_XK_FONT_HEADING4','Heading 4');
define('_XK_FONT_HEADING5','Heading 5');
define('_XK_FONT_HEADING6','Heading 6');
define('_XK_FONT_ADDRESS','Address');
define('_XK_FONT_PARAGRAPH','Paragraph');
define('_XK_FONT_FORMATTED','Formatted');

define('_XK_TOGLE_MODE','Change Mode');
define('_XK_ENABLECSS_MODE','See a real preview attaching the css theme file');
define('_XK_TABLEBORDERS_TOGGLE','Toggle Table Borders');
define('_XK_UNDO','Undo');
define('_XK_REDO','Redo');
define('_XK_FORECOLOR','Color');
define('_XK_HILITECOLOR','Hilite');
define('_XK_CUT','Cut');
define('_XK_COPY','Copy');
define('_XK_PASTE','Paste');
define('_XK_PASTESPECIAL','Paste Special...');
define('_XK_PASTEINSTRUCTIONS','Use Ctrl+v to paste');
define('_XK_BOLD','Bold');
define('_XK_ITALIC','Italic');
define('_XK_UNDERLINE','Underline');
define('_XK_STRIKETHROUGH','Strikethrouhg');
define('_XK_REMOVEFORMAT','Remove Format');
define('_XK_JUSTIFYLEFT','Justify Left');
define('_XK_JUSTIFYCENTER','Justify Center');
define('_XK_JUSTIFYRIGHT','Justify Right');
define('_XK_JUSTIFYFULL','Justify Full');
define('_XK_NEWPARAGRAPH','Turn On/Off New Paragraph Mode');
define('_XK_INSERTORDEREDLIST','Ordered List');
define('_XK_INSERTUNORDEREDLIST','Bulleted List');
define('_XK_SPELLCHECK','Spellcheck');
define('_XK_PRINT','Print');
define('_XK_INDENT','Indent');
define('_XK_OUTDENT','Outdent');
define('_XK_SUPERSCRIPT','SuperScript');
define('_XK_SUBSCRIPT','SubScript');
define('_XK_CODE','Code');
define('_XK_QUOTE','Quote');
define('_XK_CREATELINK','Create link');
define('_XK_UNLINK','Remove Link');
define('_XK_INSERTHORIZONTALRULE','Insert Horizontal Rule');
define('_XK_INSERTANCHOR','Insert Anchor');
define('_XK_CREATEQUICKTABLE','Insert Quick Table');
define('_XK_INSERTIMAGE','Insert Image');
define('_XK_INSERTIMAGEM','Image Manager');
define('_XK_FLOAT','Floating/Static Toolbar');
define('_XK_SYMBOLS','Symbols');
define('_XK_INSERTDATE','Insert Time and Date');
define('_XK_CLASS','Class');

//Image properties dialog
define('_XK_EDITIMAGE','Edit Image');
define('_XK_IMAGE','Image');
define('_XK_IMAGEWIDTH','Image width');
define('_XK_IMAGEHEIGHT','Image height');
define('_XK_IMAGEPROPS','Image Properties');
define('_XK_MARGINS','Margins');
define('_XK_ALT','Alt');
define('_XK_SRC','Source');
define('_XK_IMAGEALIGN','Image Align');
define('_XK_HSPACE','V Space.');
define('_XK_VSPACE','H Space.');
define('_XK_BWIDTH','Width');

//table dialog
define('_XK_INSERTTABLE','Insert Table');
define('_XK_EDITTABLE','Edit Table');
define('_XK_ROWS','Number of rows');
define('_XK_COLS','Number of columns');
define('_XK_WIDTH','Width');
define('_XK_HEIGHT','Height');
define('_XK_UNITS','Units');
define('_XK_BORDER','Border');
define('_XK_HALIGNMENT','Horizontal Alignment');
define('_XK_VALIGNMENT','Vertical Alignment');
define('_XK_SPACING','Cell Spacing');
define('_XK_PADDING','Cell Padding');
define('_XK_LEFT','Left');
define('_XK_RIGHT','Right');
define('_XK_CENTER','Center');
define('_XK_TOP','Top');
define('_XK_TEXTTOP','Text Top');
define('_XK_MIDDLE','Middle');
define('_XK_ABSMIDDLE','Absolute Middle');
define('_XK_BOTTOM','Bottom');
define('_XK_ABSBOTTOM','Absolute Bottom');
define('_XK_BASELINE','Baseline');
define('_XK_DEFAULT','Default');
define('_XK_BORDERCOLOR','Border Color');
define('_XK_BCOLLPASE','Border Collapse');


//table tools
define('_XK_INSERTCELL','Insert Cell');
define('_XK_INSERTCOL','Insert Col');
define('_XK_INSERTROW','Insert Row');
define('_XK_DELCELL','Del Cell');
define('_XK_DELROW','Del Row');
define('_XK_DELCOL','Del Col');
define('_XK_TABLEPROPS','Table Properties');
define('_XK_TABLETOOLS','Table Tools');
define('_XK_MORECOLSPAN','More Col Span');
define('_XK_LESSCOLSPAN','Less Col Span');
define('_XK_MOREROWSPAN','More Row Span');
define('_XK_LESSROWSPAN','Less Row Span');

//CELL TOOLS
define('_XK_IMGBACK','Background Image');
define('_XK_CELLALIGN','Cell Align');
define('_XK_CELLPROPS','Cell Properties');
define('_XK_CELLALIGNLEFTTOP','Left Top');
define('_XK_CELLALIGNLEFTMIDDLE','Left Middle');
define('_XK_CELLALIGNLEFTBOTTOM','Left Bottom');
define('_XK_CELLALIGNRIGHTTOP','Right Top');
define('_XK_CELLALIGNRIGHTMIDDLE','Right Middle');
define('_XK_CELLALIGNRIGHTBOTTOM','Right Bottom');
define('_XK_CELLALIGNCENTERTOP','Center Top');
define('_XK_CELLALIGNCENTERMIDDLE','Center Middle');
define('_XK_CELLALIGNCENTERBOTTOM','Center Bottom');
define('_XK_PREVIEW','Preview');
define('_XK_OTHERS','Others');
define('_XK_CELLOVERFLOW','Overflow');
define('_XK_CELLWIDTH','Width');
define('_XK_CELLHEIGHT','Height');
define('_XK_CELLPADDING','Cell Padding');

//BORDERS
define('_XK_BORDERS','Borders');
define('_XK_BORDERSWIDTH','Borders Width');
define('_XK_BORDERLEFT','Border Left');
define('_XK_BORDERRIGHT','Border Right');
define('_XK_BORDERTOP','Border Top');
define('_XK_BORDERBOTTOM','Border Bottom');

//REMOVE FORMAT
define('_XK_REMOVE_DESC','Remove Format Tools');
define('_XK_REMOVE_LINEBREAKS','Remove LineBreaks');
define('_XK_REMOVE_SPANF','Delete <strong>&lt;span&gt;</strong> tags');
define('_XK_REMOVE_FONTF','Delete <strong>&lt;font&gt;</strong> tags');
define('_XK_REMOVE_WORDF','Delete Word Format');
define('_XK_REMOVE_EMPTYF','Delete empty Tags');
define('_XK_REMOVE_ALLF','Del All Format');
define('_XK_CLOSE_APASTE','Close window After Paste');
?>
